package ir.pass.analyze;

import ir.Value;
import ir.instr.Instr;
import ir.value.Module;
import ir.value.User;

import java.util.ArrayList;
import java.util.LinkedHashSet;

public class RemoveUselessUser {
    public static void run(Module module){
        LinkedHashSet<Value> users = new LinkedHashSet<Value>();
        for(var func : module.functions.values()){
            for(var block : func.blocks){
                for(var inst : block.getInsts()){
                    users.add(inst);
                }
            }
        }
        for(var func : module.functions.values()){
            for(var block : func.blocks){
                for(var inst : block.getInsts()){
                    for(var used : ((Instr)inst).getOperands()){
                        used.addUser((User) inst);
                    }
                    ArrayList<User> needremove = new ArrayList<>();
                    for(var user : inst.users){
                        if(!users.contains(user)){
                            needremove.add(user);
                        }
                    }
                    inst.users.removeAll(needremove);
                }
            }
        }
        for(var inst : module.init.getInsts()){
            for(var used : ((Instr)inst).getOperands()){
                used.addUser((User) inst);
            }
            ArrayList<User> needremove = new ArrayList<>();
            for(var user : inst.users){
                if(!users.contains(user)){
                    needremove.add(user);
                }
            }
            inst.users.removeAll(needremove);
        }

    }
}
